Skip to content

# Module: "renderer-api/components"

## Index

### Enumerations

- NotificationStatus
- TooltipPosition

### Classes

- Badge
- Button
- Checkbox
- CommandOverlay
- ConfirmDialog
- CubeSpinner
- Dialog
- Drawer
- DrawerItem
- DrawerParamToggler
- DrawerTitle
- Icon
- Input
- KubeEventDetails
- KubeObjectDetails
- KubeObjectListLayout
- KubeObjectMenu
- KubeObjectMeta
- LineProgress
- Menu
- MenuActions
- MenuItem
- NamespaceSelect
- Notifications
- NotificationsStore
- PageLayout
- PodDetailsList
- Radio
- RadioGroup
- Select
- Slider
- Spinner
- StatusBrick
- Stepper
- Tab
- Table
- TableCell
- TableHead
- TableRow
- Tabs
- Tooltip
- Wizard
- WizardLayout
- WizardStep

### Interfaces

- BadgeProps
- ButtonProps
- CheckboxProps
- ConfirmDialogBooleanParams
- ConfirmDialogParams
- ConfirmDialogProps
- CubeSpinnerProps
- DialogProps
- DrawerItemLabelsProps
- DrawerItemProps
- DrawerParamTogglerProps
- DrawerProps
- DrawerTitleProps
- GroupSelectOption
- IconProps
- InputValidator
- KubeEventDetailsProps
- KubeObjectDetailsProps
- KubeObjectListLayoutProps
- KubeObjectMenuProps
- KubeObjectMetaProps
- LineProgressProps
- MenuActionsProps
- MenuItemProps
- MenuPosition
- MenuProps
- Notification
- PageLayoutProps
- RadioGroupProps
- SelectOption
- SelectProps
- SliderProps
- SpinnerProps
- StatusBrickProps
- StepperProps
- TabLayoutProps
- TabLayoutRoute
- TabProps
- TableCellProps
- TableHeadProps
- TableProps
- TableRowProps
- TabsProps
- TooltipContentFormatters
- TooltipDecoratorProps
- TooltipProps
- WizardLayoutProps
- WizardProps
- WizardStepProps

### Type aliases

- InputProps
- MenuContextValue
- NotificationId
- NotificationMessage
- RadioProps
- TableCellElem
- TableHeadElem
- TableOrderBy
- TableRowElem
- TableSortBy
- TableSortCallback
- TableSortCallbacks
- TableSortParams

### Variables

- InputValidators
- MenuContext
- TabLayout
- kubeDetailsUrlParam
- kubeSelectedUrlParam
- logTabStore
- notificationsStore
- orderByUrlParam
- sortByUrlParam
- terminalStore

### Functions

- DrawerItemLabels
- SubMenu
- createTerminalTab
- getDetailsUrl
- hideDetails
- showDetails
- withTooltip

## Type aliases

### InputProps

Ƭ InputProps: Omit‹InputElementProps, "onChange" | "onSubmit"› & object

Defined in src/renderer/components/input/input.tsx:21

### MenuContextValue

Ƭ MenuContextValue: Menu

Defined in src/renderer/components/menu/menu.tsx:11

### NotificationId

Ƭ NotificationId: string | number

Defined in src/renderer/components/notifications/notifications.store.tsx:7

### NotificationMessage

Ƭ NotificationMessage: React.ReactNode | React.ReactNode[] | JsonApiErrorParsed

Defined in src/renderer/components/notifications/notifications.store.tsx:8

### RadioProps

Ƭ RadioProps: HTMLProps‹any› & object

Defined in src/renderer/components/radio/radio.tsx:40

### TableCellElem

Ƭ TableCellElem: ReactElement‹TableCellProps›

Defined in src/renderer/components/table/table-cell.tsx:9

### TableHeadElem

Ƭ TableHeadElem: ReactElement‹TableHeadProps›

Defined in src/renderer/components/table/table-head.tsx:6

### TableOrderBy

Ƭ TableOrderBy: "asc" | "desc" | string

Defined in src/renderer/components/table/table.tsx:17

### TableRowElem

Ƭ TableRowElem: ReactElement‹TableRowProps›

Defined in src/renderer/components/table/table-row.tsx:7

### TableSortBy

Ƭ TableSortBy: string

Defined in src/renderer/components/table/table.tsx:16

### TableSortCallback

Ƭ TableSortCallback: function

Defined in src/renderer/components/table/table.tsx:19

#### Type declaration:

▸ (`data`: D): string | number | (string | number)[]

Parameters:

Name | Type
--- | ---
`data` | D

### TableSortCallbacks

Ƭ TableSortCallbacks: object

Defined in src/renderer/components/table/table.tsx:20

#### Type declaration:

- [ columnId: string]: TableSortCallback

### TableSortParams

Ƭ TableSortParams: object

Defined in src/renderer/components/table/table.tsx:18

#### Type declaration:

- orderBy: TableOrderBy

- sortBy: TableSortBy

## Variables

### InputValidators

• InputValidators: InputValidators

Defined in src/renderer/components/input/input.tsx:14

### `Const` MenuContext

• MenuContext: Context‹Menu‹›› = React.createContext(null)

Defined in src/renderer/components/menu/menu.tsx:10

### `Const` TabLayout

• TabLayout: (Anonymous function) = observer(({ className, contentClass, tabs = [], children }: TabLayoutProps) => { const currentLocation = navigation.location.pathname; const hasTabs = tabs.length > 0; const startTabUrl = hasTabs ? (tabs.find(tab => tab.default) || tabs[0])?.url : null;

return (

{hasTabs && ( navigate(url)}> {tabs.map(({ title, routePath, url = routePath, exact }) => { const isActive = !!matchPath(currentLocation, { path: routePath, exact });

            return <Tab key={url} label={title} value={url} active={isActive}/>;
          })}
        </Tabs>
      )}
      <main className={cssNames(contentClass)}>
        <ErrorBoundary>
          {hasTabs && (
            <Switch>
              {tabs.map(({ routePath, exact, component }) => {
                return <Route key={routePath} exact={exact} path={routePath} component={component}/>;
              })}
              <Redirect to={startTabUrl}/>
            </Switch>
          )}
          {children}
        </ErrorBoundary>
      </main>
    </div>

); })

Defined in src/renderer/components/layout/tab-layout.tsx:27

### `Const` kubeDetailsUrlParam

• kubeDetailsUrlParam: PageParam‹string› = createPageParam({ name: "kube-details", isSystem: true, })

Defined in src/renderer/components/kube-object/kube-object-details.tsx:19

Used to store `object.selfLink` to show more info about resource in the details panel.

### `Const` kubeSelectedUrlParam

• kubeSelectedUrlParam: PageParam‹string› = createPageParam({ name: "kube-selected", isSystem: true, get defaultValue() { return kubeDetailsUrlParam.get(); } })

Defined in src/renderer/components/kube-object/kube-object-details.tsx:31

Used to highlight last active/selected table row with the resource.

`example` If we go to "Nodes (page) -> Node (details) -> Pod (details)", last clicked Node should be "active" while Pod details are shown).

### `Const` logTabStore

• logTabStore: LogTabStore‹› = new LogTabStore()

Defined in src/renderer/components/dock/log-tab.store.ts:119

### `Const` notificationsStore

• notificationsStore: NotificationsStore‹› = new NotificationsStore()

Defined in src/renderer/components/notifications/notifications.store.tsx:78

### `Const` orderByUrlParam

• orderByUrlParam: PageParam‹string› = createPageParam({ name: "order", isSystem: true, })

Defined in src/renderer/components/table/table.tsx:52

### `Const` sortByUrlParam

• sortByUrlParam: PageParam‹string› = createPageParam({ name: "sort", isSystem: true, })

Defined in src/renderer/components/table/table.tsx:47

### `Const` terminalStore

• terminalStore: TerminalStore‹› = new TerminalStore()

Defined in src/renderer/components/dock/terminal.store.ts:122

## Functions

### DrawerItemLabels

▸ DrawerItemLabels(`props`: DrawerItemLabelsProps): Element‹›

Defined in src/renderer/components/drawer/drawer-item-labels.tsx:9

Parameters:

Name | Type
--- | ---
`props` | DrawerItemLabelsProps

Returns: Element‹›

### SubMenu

▸ SubMenu(`props`: Partial‹MenuProps›): Element‹›

Defined in src/renderer/components/menu/menu.tsx:289

Parameters:

Name | Type
--- | ---
`props` | Partial‹MenuProps›

Returns: Element‹›

### createTerminalTab

▸ createTerminalTab(`tabParams`: Partial‹ITerminalTab›): IDockTab

Defined in src/renderer/components/dock/terminal.store.ts:16

Parameters:

Name | Type | Default
--- | --- | ---
`tabParams` | Partial‹ITerminalTab› | {}

Returns: IDockTab

### getDetailsUrl

▸ getDetailsUrl(`selfLink`: string, `resetSelected`: boolean, `mergeGlobals`: boolean): string

Defined in src/renderer/components/kube-object/kube-object-details.tsx:49

Parameters:

Name | Type | Default
--- | --- | ---
`selfLink` | string | -
`resetSelected` | boolean | false
`mergeGlobals` | boolean | true

Returns: string

### hideDetails

▸ hideDetails(): void

Defined in src/renderer/components/kube-object/kube-object-details.tsx:45

Returns: void

### showDetails

▸ showDetails(`selfLink`: string, `resetSelected`: boolean): void

Defined in src/renderer/components/kube-object/kube-object-details.tsx:39

Parameters:

Name | Type | Default
--- | --- | ---
`selfLink` | string | ""
`resetSelected` | boolean | true

Returns: void

### withTooltip

▸ withTooltip‹T›(`Target`: T): T

Defined in src/renderer/components/tooltip/withTooltip.tsx:18

Type parameters:

▪ T: React.ComponentType‹any›

Parameters:

Name | Type
--- | ---
`Target` | T

Returns: T